POJ2479(最长连续子序列和)

Maximum sum

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 37035   Accepted: 11551

Description

Given a set of n integers: A={a1, a2,..., an}, we define a function d(A) as below:

Your task is to calculate d(A).

Input

The input consists of T(<=30) test cases. The number of test cases (T) is given in the first line of the input. 
Each test case contains two lines. The first line is an integer n(2<=n<=50000). The second line contains n integers: a1, a2, ..., an. (|ai| <= 10000).There is an empty line after each case.

Output

Print exactly one line for each test case. The line should contain the integer d(A).

Sample Input

1

10
1 -1 2 2 3 -3 4 -4 5 -5

Sample Output

13

Hint

In the sample, we choose {2,2,3,-3,4} and {5}, then we can get the answer.

Huge input,scanf is recommended.

Source

POJ Contest,Author:[email protected]

题意:原串分成两个不相交连续子序列,求最大和

const int maxn = 50010;

int num[maxn];
int le[maxn], ri[maxn];

int main() {

    int T;
    scanf("%d", &T);
    while (T --) {
        memset(le, 0, sizeof(le));
        memset(ri, 0, sizeof(ri));
        int n;
        scanf("%d", &n);
        for (int i = 1; i <= n; i ++) scanf("%d", &num[i]);
        le[1] = num[1];
        ri[n] = num[n];
        int cur_sum = num[1] < 0 ? 0 : num[1];
        for (int i = 2; i <= n; i ++) {
            cur_sum += num[i];
            le[i] = max(le[i-1], cur_sum);
            if (cur_sum < 0) cur_sum = 0;
        }
        cur_sum = num[n] < 0 ? 0 : num[n];
        for (int i = n - 1; i >= 1; i --) {
            cur_sum += num[i];
            ri[i] = max(ri[i+1], cur_sum);
            if (cur_sum < 0) cur_sum = 0;
        }
        int ans = -0x3fffffff;
        for (int i = 2; i <= n; i ++) {
            ans = max(ans, le[i-1] + ri[i]);
        }
        printf("%d\n", ans);
    }

    return 0;
}
时间: 2024-11-03 21:08:17

POJ2479(最长连续子序列和)的相关文章

求和为0的最长连续子序列长度

  题意:给定一个数组,数组中元素的值只能是1或者-1,求其和为0的最长连续子序列的长度: 数组为1,-1,1,-1,1,-1,1,-1,其结果为:8 数组为1,1,-1,1,1,-1,-1,其结果为:6 解析: 通过分析可知,要使其和为0,只有当1和-1的个数相等时,才会成立,但题目要求是连续子序列,所以单纯统计其1和-1个数不可取. 由题目中求最长连续子序列,可想到动态规划来求解,动态规划的求解既是寻找其状态转移方程和建立状态转移表的过程 设dp[i]为下标为i及其之前数组中所有元素的和,

HDU1231 最长连续子序列

最大连续子序列 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 31687    Accepted Submission(s): 14214 Problem Description 给定K个整数的序列{ N1, N2, ..., NK },其任意连续子序列可表示为{ Ni, Ni+1, ..., Nj },其中 1 <= i <= j

算法面试题 之 最长连续子序列之和

参考 http://www.ahathinking.com/archives/120.html var arr = [2, 8,-2, 3, 5, -3, 2]; //传统方法 O(n^2) function fun1(arr){ var maxSum =arr[0]; var maxSumArr = []; for(var i=0; i< arr.length; i++){ var sum = arr[i]; var sumArr = [arr[i]]; for(j=i+1; j<arr.l

leetcode 128. 最长连续子序列

题目描述: 给定一个未排序的整数数组,找出最长连续序列的长度. 要求算法的时间复杂度为 O(n). 示例: 输入:[100, 4, 200, 1, 3, 2] 输出:4 即最长的连续序列为 [1,2,3,4] 思路分析: 由于要求O(n)的复杂读,因此直接排序是不可行的. 这里用到的是并查集的思想.对于每一个数,去查小于1和大于1的数是否在序列中.通过迭代求解. 尽管在 for 循环中嵌套了一个 while 循环,时间复杂度看起来像是二次方级别的.但其实它是线性的算法.因为只有当 current

csu 1553: Good subsequence (最长连续子序列)

http://acm.csu.edu.cn/OnlineJudge/problem.php?cid=2071&pid=6 题意:有一个由n个数组成的序列 要求出一个满足 max-min<=k 的最长子序列 思路:(听说数据大的情况可以用单调栈解决 但是我只是纯粹暴力了) 首先枚举左界 把max和min都赋值为 a[i] 再枚举右界 每次判断max-min是否小于等于k 求出最大值 #include<cstdio> #include<iostream> #include

HDU 3308 线段树单点更新+区间查找最长连续子序列

LCIS                                                              Time Limit: 6000/2000 MS (Java/Others)                                                                 Memory Limit: 65536/32768 K (Java/Others)                                       

BNUOJ 4215 最长公共连续子序列

最长公共连续子序列 Time Limit: 1000ms Memory Limit: 65536KB 64-bit integer IO format: %lld      Java class name: Main 给你两个序列S1和S2,长度分别是L1,L2 (1 <= L1 , L2 <= 180). 写一个程序找出最长的连续公共子序列. 连续子序列定义为序列中连续的一个片段.例如序列"1 2 3"的子串有空串,"1","2",

最长递增子序列长度算法

求最长连续子序列的长度,数字保存在数组中 使用动态规划,理解好转移状态,dp[i]表示i位置下的最大连续子序列长度. 初始状态dp[0] = 1,表示在数组下标为0的时候,它的最长子序列长度就是1, 接着从1开始从左到右扫描,如果后一个数大于前一个数,则它的最长子序列长度增加1,否则, 此位置的最长子序列长度置为1,同时记录下当前的最大子序列长度: 最后返回记录的最大连续子序列变量.代码如下: Code(C++): //最大连续非降序列长度 int maxSubLen(vector<int>

牛牛的数列 最长递增子序列

题目: https://www.nowcoder.com/questionTerminal/4e1012fe691b446d88eba5db8f511692 要求一个最长连续子序列,这个序列中只更改一个数字,便是最长连续递增子序列. 设更改的数字位于A[i],对A[i],计算出以A[i-1]为结尾的最长递增子序列,以A[i+1]为开始的最长子序列,再根据A[i-1] 与 A[i+1]的大小关系,确定更改A[i]时的最长连续递增子序列的长度. #include <iostream> #inclu